Index: sansmodels/src/c_extensions/sld_cal.h
===================================================================
--- sansmodels/src/c_extensions/sld_cal.h	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_extensions/sld_cal.h	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -1,4 +1,5 @@
 #if !defined(sld_cal_h)
 #define sld_cal_h
+#include "parameters.hh"
 
 /**
@@ -12,39 +13,43 @@
 
  **/
-typedef struct {
-    ///	fun_type
-    //  [DEFAULT]=fun_type=0
-    double fun_type;
 
-    /// npts_inter
-    //  [DEFAULT]=npts_inter= 21
-    double npts_inter;
+class SLDCalFunc{
+public:
+  // Model parameters
+  /// fun_type
+  //  [DEFAULT]=fun_type=0
+  Parameter fun_type;
 
-    /// shell_num
-    //  [DEFAULT]=shell_num= 0
-    double shell_num;
+  /// npts_inter
+  //  [DEFAULT]=npts_inter= 21
+  Parameter npts_inter;
 
-    /// nu_inter
-    //  [DEFAULT]=nu_inter= 2.5
-    double nu_inter;
+  /// shell_num
+  //  [DEFAULT]=shell_num= 0
+  Parameter shell_num;
 
-    /// sld_left [1/A^(2)]
-    //  [DEFAULT]=sld_left= 0 [1/A^(2)]
-    double sld_left;
+  /// nu_inter
+  //  [DEFAULT]=nu_inter= 2.5
+  Parameter nu_inter;
 
-    /// sld_right [1/A^(2)]
-    //  [DEFAULT]=sld_right= 0 [1/A^(2)]
-    double sld_right;
+  /// sld_left [1/A^(2)]
+  //  [DEFAULT]=sld_left= 0 [1/A^(2)]
+  Parameter sld_left;
 
-} SLDCalParameters;
+  /// sld_right [1/A^(2)]
+  //  [DEFAULT]=sld_right= 0 [1/A^(2)]
+  Parameter sld_right;
+
+  // Constructor
+  SLDCalFunc();
+
+  // Operators to get SLD
+  double operator()(double q);
+  double operator()(double qx, double qy);
+  double calculate_ER();
+  double evaluate_rphi(double q, double phi);
+};
 
 
 
-/// 1D function
-double sld_cal_analytical_1D(SLDCalParameters *pars, double q);
-
-/// 2D function
-double sld_cal_analytical_2D(SLDCalParameters *pars, double q, double phi);
-double sld_cal_analytical_2DXY(SLDCalParameters *pars, double qx, double qy);
-
 #endif
Index: sansmodels/src/c_models/DiamCyl.cpp
===================================================================
--- sansmodels/src/c_models/DiamCyl.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/DiamCyl.cpp	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -18,16 +18,14 @@
  *   sansmodels/src/libigor
  *
- *	TODO: refactor so that we pull in the old sansmodels.c_extensions
  */
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "DiamCyl.h"
 
 extern "C" {
 	#include "libStructureFactor.h"
-	#include "DiamCyl.h"
 }
 
@@ -112,37 +110,2 @@
   return 0.0;
 }
-// Testing code
-
-/**
-int main(void)
-{
-	DiamCylFunc c = DiamCylFunc();
-
-	printf("I(Qx=%g,Qy=%g) = %g\n", 0.001, 0.001, c(0.001, 0.001));
-	printf("I(Q=%g) = %g\n", 0.001, c(0.001));
-	c.radius.dispersion = new GaussianDispersion();
-	c.radius.dispersion->npts = 100;
-	c.radius.dispersion->width = 20;
-
-	//c.length.dispersion = GaussianDispersion();
-	//c.length.dispersion.npts = 20;
-	//c.length.dispersion.width = 65;
-
-	//printf("I(Q=%g) = %g\n", 0.001, c(0.001));
-	//printf("I(Q=%g) = %g\n", 0.001, c(0.001));
-	//printf("I(Qx=%g, Qy=%g) = %g\n", 0.001, 0.001, c(0.001, 0.001));
-	//printf("I(Q=%g,  Phi=%g) = %g\n", 0.00447, .7854, c.evaluate_rphi(sqrt(0.00002), .7854));
-
-
-
-	double i_avg = c(0.01, 0.01);
-	double i_1d = c(sqrt(0.0002));
-
-	printf("\nI(Qx=%g, Qy=%g) = %g\n", 0.01, 0.01, i_avg);
-	printf("I(Q=%g)         = %g\n", sqrt(0.0002), i_1d);
-	printf("ratio %g %g\n", i_avg/i_1d, i_1d/i_avg);
-
-
-	return 0;
-}
- **/
Index: sansmodels/src/c_models/DiamEllip.cpp
===================================================================
--- sansmodels/src/c_models/DiamEllip.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/DiamEllip.cpp	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -21,12 +21,11 @@
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "DiamEllip.h"
 
 extern "C" {
 	#include "libStructureFactor.h"
-	#include "DiamEllip.h"
 }
 
@@ -109,36 +108,2 @@
   return 0.0;
 }
-// Testing code
-/*
-int main(void)
-{
-	SquareWellModel c = SquareWellModel();
-
-	printf("I(Qx=%g,Qy=%g) = %g\n", 0.001, 0.001, c(0.001, 0.001));
-	printf("I(Q=%g) = %g\n", 0.001, c(0.001));
-	c.radius.dispersion = new GaussianDispersion();
-	c.radius.dispersion->npts = 100;
-	c.radius.dispersion->width = 5;
-
-	//c.length.dispersion = GaussianDispersion();
-	//c.length.dispersion.npts = 20;
-	//c.length.dispersion.width = 65;
-
-	printf("I(Q=%g) = %g\n", 0.001, c(0.001));
-	printf("I(Q=%g) = %g\n", 0.001, c(0.001));
-	printf("I(Qx=%g, Qy=%g) = %g\n", 0.001, 0.001, c(0.001, 0.001));
-	printf("I(Q=%g,  Phi=%g) = %g\n", 0.00447, .7854, c.evaluate_rphi(sqrt(0.00002), .7854));
-
-
-
-	double i_avg = c(0.01, 0.01);
-	double i_1d = c(sqrt(0.0002));
-
-	printf("\nI(Qx=%g, Qy=%g) = %g\n", 0.01, 0.01, i_avg);
-	printf("I(Q=%g)         = %g\n", sqrt(0.0002), i_1d);
-	printf("ratio %g %g\n", i_avg/i_1d, i_1d/i_avg);
-
-
-	return 0;
-}
-*/
Index: sansmodels/src/c_models/Hardsphere.cpp
===================================================================
--- sansmodels/src/c_models/Hardsphere.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/Hardsphere.cpp	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -22,19 +22,18 @@
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "Hardsphere.h"
 
 extern "C" {
-	#include "libStructureFactor.h"
-	#include "Hardsphere.h"
+#include "libStructureFactor.h"
 }
 
 HardsphereStructure :: HardsphereStructure() {
-	effect_radius      = Parameter(50.0, true);
-	effect_radius.set_min(0.0);
-	volfraction = Parameter(0.20, true);
-	volfraction.set_min(0.0);
+  effect_radius      = Parameter(50.0, true);
+  effect_radius.set_min(0.0);
+  volfraction = Parameter(0.20, true);
+  volfraction.set_min(0.0);
 }
 
@@ -46,28 +45,28 @@
  */
 double HardsphereStructure :: operator()(double q) {
-	double dp[2];
+  double dp[2];
 
-	// Fill parameter array for IGOR library
-	// Add the background after averaging
-	dp[0] = effect_radius();
-	dp[1] = volfraction();
+  // Fill parameter array for IGOR library
+  // Add the background after averaging
+  dp[0] = effect_radius();
+  dp[1] = volfraction();
 
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_rad;
-	effect_radius.get_weights(weights_rad);
+  // Get the dispersion points for the radius
+  vector<WeightPoint> weights_rad;
+  effect_radius.get_weights(weights_rad);
 
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
 
-	// Loop over radius weight points
-	for(size_t i=0; i<weights_rad.size(); i++) {
-		dp[0] = weights_rad[i].value;
+  // Loop over radius weight points
+  for(size_t i=0; i<weights_rad.size(); i++) {
+    dp[0] = weights_rad[i].value;
 
-		sum += weights_rad[i].weight
-				* HardSphereStruct(dp, q);
-		norm += weights_rad[i].weight;
-	}
-	return sum/norm ;
+    sum += weights_rad[i].weight
+        * HardSphereStruct(dp, q);
+    norm += weights_rad[i].weight;
+  }
+  return sum/norm ;
 }
 
@@ -79,6 +78,6 @@
  */
 double HardsphereStructure :: operator()(double qx, double qy) {
-	double q = sqrt(qx*qx + qy*qy);
-	return (*this).operator()(q);
+  double q = sqrt(qx*qx + qy*qy);
+  return (*this).operator()(q);
 }
 
@@ -91,7 +90,7 @@
  */
 double HardsphereStructure :: evaluate_rphi(double q, double phi) {
-	double qx = q*cos(phi);
-	double qy = q*sin(phi);
-	return (*this).operator()(qx, qy);
+  double qx = q*cos(phi);
+  double qy = q*sin(phi);
+  return (*this).operator()(qx, qy);
 }
 /**
@@ -100,5 +99,5 @@
  */
 double HardsphereStructure :: calculate_ER() {
-//NOT implemented yet!!!
+  //NOT implemented yet!!!
   return 0.0;
 }
Index: sansmodels/src/c_models/HayterMSA.cpp
===================================================================
--- sansmodels/src/c_models/HayterMSA.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/HayterMSA.cpp	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -22,24 +22,23 @@
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "HayterMSA.h"
 
 extern "C" {
-	#include "libStructureFactor.h"
-	#include "HayterMSA.h"
+#include "libStructureFactor.h"
 }
 
 HayterMSAStructure :: HayterMSAStructure() {
-	effect_radius      = Parameter(20.75, true);
-	effect_radius.set_min(0.0);
-	charge      = Parameter(19.0, true);
-	volfraction = Parameter(0.0192, true);
-	volfraction.set_min(0.0);
-	temperature = Parameter(318.16, true);
-	temperature.set_min(0.0);
-	saltconc   = Parameter(0.0);
-	dielectconst  = Parameter(71.08);
+  effect_radius      = Parameter(20.75, true);
+  effect_radius.set_min(0.0);
+  charge      = Parameter(19.0, true);
+  volfraction = Parameter(0.0192, true);
+  volfraction.set_min(0.0);
+  temperature = Parameter(318.16, true);
+  temperature.set_min(0.0);
+  saltconc   = Parameter(0.0);
+  dielectconst  = Parameter(71.08);
 }
 
@@ -51,32 +50,32 @@
  */
 double HayterMSAStructure :: operator()(double q) {
-	double dp[6];
+  double dp[6];
 
-	// Fill parameter array for IGOR library
-	// Add the background after averaging
-	dp[0] = 2.0*effect_radius();
-	dp[1] = fabs(charge());
-	dp[2] = volfraction();
-	dp[3] = temperature();
-	dp[4] = saltconc();
-	dp[5] = dielectconst();
+  // Fill parameter array for IGOR library
+  // Add the background after averaging
+  dp[0] = 2.0*effect_radius();
+  dp[1] = fabs(charge());
+  dp[2] = volfraction();
+  dp[3] = temperature();
+  dp[4] = saltconc();
+  dp[5] = dielectconst();
 
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_rad;
-	effect_radius.get_weights(weights_rad);
+  // Get the dispersion points for the radius
+  vector<WeightPoint> weights_rad;
+  effect_radius.get_weights(weights_rad);
 
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
 
-	// Loop over radius weight points
-	for(size_t i=0; i<weights_rad.size(); i++) {
-		dp[0] = 2.0*weights_rad[i].value;
+  // Loop over radius weight points
+  for(size_t i=0; i<weights_rad.size(); i++) {
+    dp[0] = 2.0*weights_rad[i].value;
 
-		sum += weights_rad[i].weight
-				* HayterPenfoldMSA(dp, q);
-		norm += weights_rad[i].weight;
-	}
-	return sum/norm ;
+    sum += weights_rad[i].weight
+        * HayterPenfoldMSA(dp, q);
+    norm += weights_rad[i].weight;
+  }
+  return sum/norm ;
 }
 
@@ -88,6 +87,6 @@
  */
 double HayterMSAStructure :: operator()(double qx, double qy) {
-	double q = sqrt(qx*qx + qy*qy);
-	return (*this).operator()(q);
+  double q = sqrt(qx*qx + qy*qy);
+  return (*this).operator()(q);
 }
 
@@ -100,7 +99,7 @@
  */
 double HayterMSAStructure :: evaluate_rphi(double q, double phi) {
-	double qx = q*cos(phi);
-	double qy = q*sin(phi);
-	return (*this).operator()(qx, qy);
+  double qx = q*cos(phi);
+  double qy = q*sin(phi);
+  return (*this).operator()(qx, qy);
 }
 /**
@@ -109,40 +108,5 @@
  */
 double HayterMSAStructure :: calculate_ER() {
-//NOT implemented yet!!!
+  //NOT implemented yet!!!
   return 0.0;
 }
-
-// Testing code
-/*
-int main(void)
-{
-	SquareWellModel c = SquareWellModel();
-
-	printf("I(Qx=%g,Qy=%g) = %g\n", 0.001, 0.001, c(0.001, 0.001));
-	printf("I(Q=%g) = %g\n", 0.001, c(0.001));
-	c.radius.dispersion = new GaussianDispersion();
-	c.radius.dispersion->npts = 100;
-	c.radius.dispersion->width = 5;
-
-	//c.length.dispersion = GaussianDispersion();
-	//c.length.dispersion.npts = 20;
-	//c.length.dispersion.width = 65;
-
-	printf("I(Q=%g) = %g\n", 0.001, c(0.001));
-	printf("I(Q=%g) = %g\n", 0.001, c(0.001));
-	printf("I(Qx=%g, Qy=%g) = %g\n", 0.001, 0.001, c(0.001, 0.001));
-	printf("I(Q=%g,  Phi=%g) = %g\n", 0.00447, .7854, c.evaluate_rphi(sqrt(0.00002), .7854));
-
-
-
-	double i_avg = c(0.01, 0.01);
-	double i_1d = c(sqrt(0.0002));
-
-	printf("\nI(Qx=%g, Qy=%g) = %g\n", 0.01, 0.01, i_avg);
-	printf("I(Q=%g)         = %g\n", sqrt(0.0002), i_1d);
-	printf("ratio %g %g\n", i_avg/i_1d, i_1d/i_avg);
-
-
-	return 0;
-}
-*/
Index: sansmodels/src/c_models/SquareWell.cpp
===================================================================
--- sansmodels/src/c_models/SquareWell.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/SquareWell.cpp	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -18,25 +18,23 @@
  *   sansmodels/src/libigor
  *
- *	TODO: refactor so that we pull in the old sansmodels.c_extensions
  */
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "SquareWell.h"
 
 extern "C" {
-	#include "libStructureFactor.h"
-	#include "SquareWell.h"
+#include "libStructureFactor.h"
 }
 
 SquareWellStructure :: SquareWellStructure() {
-	effect_radius      = Parameter(50.0, true);
-	effect_radius.set_min(0.0);
-	volfraction = Parameter(0.04, true);
-	volfraction.set_min(0.0);
-	welldepth   = Parameter(1.50);
-	wellwidth  = Parameter(1.20);
+  effect_radius      = Parameter(50.0, true);
+  effect_radius.set_min(0.0);
+  volfraction = Parameter(0.04, true);
+  volfraction.set_min(0.0);
+  welldepth   = Parameter(1.50);
+  wellwidth  = Parameter(1.20);
 }
 
@@ -48,30 +46,30 @@
  */
 double SquareWellStructure :: operator()(double q) {
-	double dp[4];
+  double dp[4];
 
-	// Fill parameter array for IGOR library
-	// Add the background after averaging
-	dp[0] = effect_radius();
-	dp[1] = volfraction();
-	dp[2] = welldepth();
-	dp[3] = wellwidth();
+  // Fill parameter array for IGOR library
+  // Add the background after averaging
+  dp[0] = effect_radius();
+  dp[1] = volfraction();
+  dp[2] = welldepth();
+  dp[3] = wellwidth();
 
-	// Get the dispersion points for the radius
-	vector<WeightPoint> weights_rad;
-	effect_radius.get_weights(weights_rad);
+  // Get the dispersion points for the radius
+  vector<WeightPoint> weights_rad;
+  effect_radius.get_weights(weights_rad);
 
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
 
-	// Loop over radius weight points
-	for(size_t i=0; i<weights_rad.size(); i++) {
-		dp[0] = weights_rad[i].value;
+  // Loop over radius weight points
+  for(size_t i=0; i<weights_rad.size(); i++) {
+    dp[0] = weights_rad[i].value;
 
-		sum += weights_rad[i].weight
-				* SquareWellStruct(dp, q);
-		norm += weights_rad[i].weight;
-	}
-	return sum/norm ;
+    sum += weights_rad[i].weight
+        * SquareWellStruct(dp, q);
+    norm += weights_rad[i].weight;
+  }
+  return sum/norm ;
 }
 
@@ -83,6 +81,6 @@
  */
 double SquareWellStructure :: operator()(double qx, double qy) {
-	double q = sqrt(qx*qx + qy*qy);
-	return (*this).operator()(q);
+  double q = sqrt(qx*qx + qy*qy);
+  return (*this).operator()(q);
 }
 
@@ -95,7 +93,7 @@
  */
 double SquareWellStructure :: evaluate_rphi(double q, double phi) {
-	double qx = q*cos(phi);
-	double qy = q*sin(phi);
-	return (*this).operator()(qx, qy);
+  double qx = q*cos(phi);
+  double qy = q*sin(phi);
+  return (*this).operator()(qx, qy);
 }
 /**
@@ -104,39 +102,5 @@
  */
 double SquareWellStructure :: calculate_ER() {
-//NOT implemented yet!!!
+  //NOT implemented yet!!!
   return 0.0;
 }
-// Testing code
-/*
-int main(void)
-{
-	SquareWellModel c = SquareWellModel();
-
-	printf("I(Qx=%g,Qy=%g) = %g\n", 0.001, 0.001, c(0.001, 0.001));
-	printf("I(Q=%g) = %g\n", 0.001, c(0.001));
-	c.radius.dispersion = new GaussianDispersion();
-	c.radius.dispersion->npts = 100;
-	c.radius.dispersion->width = 5;
-
-	//c.length.dispersion = GaussianDispersion();
-	//c.length.dispersion.npts = 20;
-	//c.length.dispersion.width = 65;
-
-	printf("I(Q=%g) = %g\n", 0.001, c(0.001));
-	printf("I(Q=%g) = %g\n", 0.001, c(0.001));
-	printf("I(Qx=%g, Qy=%g) = %g\n", 0.001, 0.001, c(0.001, 0.001));
-	printf("I(Q=%g,  Phi=%g) = %g\n", 0.00447, .7854, c.evaluate_rphi(sqrt(0.00002), .7854));
-
-
-
-	double i_avg = c(0.01, 0.01);
-	double i_1d = c(sqrt(0.0002));
-
-	printf("\nI(Qx=%g, Qy=%g) = %g\n", 0.01, 0.01, i_avg);
-	printf("I(Q=%g)         = %g\n", sqrt(0.0002), i_1d);
-	printf("ratio %g %g\n", i_avg/i_1d, i_1d/i_avg);
-
-
-	return 0;
-}
-*/
Index: sansmodels/src/c_models/StickyHS.cpp
===================================================================
--- sansmodels/src/c_models/StickyHS.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/StickyHS.cpp	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -22,12 +22,11 @@
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "StickyHS.h"
 
 extern "C" {
 	#include "libStructureFactor.h"
-	#include "StickyHS.h"
 }
 
Index: sansmodels/src/c_models/bcc.cpp
===================================================================
--- sansmodels/src/c_models/bcc.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/bcc.cpp	(revision 0ba3b08c35684feff124c0657dad569d13717a18)
@@ -21,12 +21,134 @@
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "bcc.h"
 
 extern "C" {
 	#include "libSphere.h"
-	#include "bcc.h"
+}
+
+// Convenience structure
+typedef struct {
+  double scale;
+  double dnn;
+  double d_factor;
+  double radius;
+  double sldSph;
+  double sldSolv;
+  double background;
+  double theta;
+  double phi;
+  double psi;
+
+} BCParameters;
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the BCCCrystalModel
+ * @param q: q-value
+ * @param q_x: q_x / q
+ * @param q_y: q_y / q
+ * @return: function value
+ */
+static double bc_analytical_2D_scaled(BCParameters *pars, double q, double q_x, double q_y) {
+  double b3_x, b3_y, b3_z, b1_x, b1_y;
+  double q_z;
+  double alpha, cos_val_b3, cos_val_b2, cos_val_b1;
+  double a1_dot_q, a2_dot_q,a3_dot_q;
+  double answer;
+  double Pi = 4.0*atan(1.0);
+  double aa, Da, qDa_2, latticeScale, Zq, Fkq, Fkq_2;
+
+  //convert angle degree to radian
+  double pi = 4.0*atan(1.0);
+  double theta = pars->theta * pi/180.0;
+  double phi = pars->phi * pi/180.0;
+  double psi = pars->psi * pi/180.0;
+
+  double dp[5];
+  dp[0] = 1.0;
+  dp[1] = pars->radius;
+  dp[2] = pars->sldSph;
+  dp[3] = pars->sldSolv;
+  dp[4] = 0.0;
+
+  aa = pars->dnn;
+  Da = pars->d_factor*aa;
+  qDa_2 = pow(q*Da,2.0);
+
+  //the occupied volume of the lattice
+  latticeScale = 2.0*(4.0/3.0)*Pi*(dp[1]*dp[1]*dp[1])/pow(aa/sqrt(3.0/4.0),3.0);
+  // q vector
+  q_z = 0.0; // for SANS; assuming qz is negligible
+  /// Angles here are respect to detector coordinate
+  ///  instead of against q coordinate(PRB 36(46), 3(6), 1754(3854))
+    // b3 axis orientation
+    b3_x = sin(theta) * cos(phi);//negative sign here???
+    b3_y = sin(theta) * sin(phi);
+    b3_z = cos(theta);
+    cos_val_b3 =  b3_x*q_x + b3_y*q_y + b3_z*q_z;
+
+    alpha = acos(cos_val_b3);
+    // b1 axis orientation
+    b1_x = sin(psi);
+    b1_y = cos(psi);
+  cos_val_b1 = (b1_x*q_x + b1_y*q_y);
+    // b2 axis orientation
+  cos_val_b2 = sin(acos(cos_val_b1));
+  // alpha corrections
+  cos_val_b2 *= sin(alpha);
+  cos_val_b1 *= sin(alpha);
+
+    // Compute the angle btw vector q and the a3 axis
+    a3_dot_q = 0.5*aa*q*(cos_val_b2+cos_val_b1-cos_val_b3);
+
+    // a1 axis
+    a1_dot_q = 0.5*aa*q*(cos_val_b3+cos_val_b2-cos_val_b1);
+
+    // a2 axis
+    a2_dot_q = 0.5*aa*q*(cos_val_b3+cos_val_b1-cos_val_b2);
+
+    // The following test should always pass
+    if (fabs(cos_val_b3)>1.0) {
+      printf("bcc_ana_2D: Unexpected error: cos(alpha)>1\n");
+      return 0;
+    }
+    // Get Fkq and Fkq_2
+    Fkq = exp(-0.5*pow(Da/aa,2.0)*(a1_dot_q*a1_dot_q+a2_dot_q*a2_dot_q+a3_dot_q*a3_dot_q));
+    Fkq_2 = Fkq*Fkq;
+    // Call Zq=Z1*Z2*Z3
+    Zq = (1.0-Fkq_2)/(1.0-2.0*Fkq*cos(a1_dot_q)+Fkq_2);
+    Zq *= (1.0-Fkq_2)/(1.0-2.0*Fkq*cos(a2_dot_q)+Fkq_2);
+    Zq *= (1.0-Fkq_2)/(1.0-2.0*Fkq*cos(a3_dot_q)+Fkq_2);
+
+  // Use SphereForm directly from libigor
+  answer = SphereForm(dp,q)*Zq;
+
+  //consider scales
+  answer *= latticeScale * pars->scale;
+
+  // This FIXES a singualrity the kernel in libigor.
+  if ( answer == INFINITY || answer == NAN){
+    answer = 0.0;
+  }
+
+  // add background
+  answer += pars->background;
+
+  return answer;
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the BCC_ParaCrystal
+ * @param q: q-value
+ * @return: function value
+ */
+static double bc_analytical_2DXY(BCParameters *pars, double qx, double qy){
+  double q;
+  q = sqrt(qx*qx+qy*qy);
+  return bc_analytical_2D_scaled(pars, q, qx/q, qy/q);
 }
 
